####################
## SERIE 1 -  IMA ##
####################

#LER
dir()
s1<-ts(read.table("serie1.txt", header = FALSE, dec="."))

#GRAFICO
plot(s1, main="Serie 1", ylab="");grid()
par(mfrow=c(1,2))
acf(s1, lag.max=30, main="ACF", ci=0)
pacf(s1,lag.max=30, main="PACF")

#PRIMEIRA DIFERENCA
ds1<-diff(s1)
plot(ds1, ylab="", main="Serie 1 Diferenciada");grid()
par(mfrow=c(1,2))
acf(ds1, lag.max=25, main="")
pacf(ds1, lag.max=25, main="")

#POSIVEIS MODELOS
mod11=arima(s1, c(0, 1, 1), method = c("ML"))
res11=residuals(mod11)

mod12=arima(s1, c(1, 1, 1), method = c("ML"))
res12=residuals(mod12)

mod13=arima(s1, c(1, 1, 0), method = c("ML"))
res13=residuals(mod13)


#ESCOLHA SEGUNDO CRITERIO DE INFO 
AIC(mod11, k=2) #AIC
AIC(mod11, k = log(length(s1))) #BIC

AIC(mod12, k=2) #AIC
AIC(mod12, k = log(length(s1))) #BIC

AIC(mod13, k=2) #AIC
AIC(mod13, k = log(length(s1))) #BIC


#ESTIMACAO DOS PARAMETROS
# Estimacao ML exacta
(mod11=arima(s1, c(0, 1, 1), method = c("ML")))
res11=residuals(mod11)


###################################################################################
#OPCIONAL (OUTROS METEDOS CSS E CSS-ML)                                           #                              #
# Estimacao ML condicional                                                        #
(mod_w1_CSS=arima(s1, c(0, 1, 1), method = c("CSS")))                             #
(res_w1_CSS=residuals(mod_w1_CSS))                                                #
# Estimacao ML exata, valores iniciais dados pela estimacao condicional (Default) # 
(mod_w1_CSS_ML=arima(s1, c(0, 1, 1), method = c("CSS-ML")))                       #
(res_w1_CSS_ML=residuals(mod_w1_CSS_ML))                                          #
###################################################################################


#ANALISE DE RESIDUAIS
par(mfrow=c(3,2))
plot.ts(res11, main="Residuales", ylab="")
hist(res11, main="Histograma de Residuales")
acf(res11, lag.max=25, main="ACF de Residuales")
pacf(res11, lag.max=25, main="PACF de Residuales")


Box.Test(res11) #Funcao Anexa ao Final

shapiro.test(res11)
qqnorm(res11, main="QQ de los Residuales")
qqline(res11)



####################################################################################
####################################################################################
####################################################################################
####################################################################################

##################
## SERIE 2 - AR ##
##################

#LER DADOS DESDE EXCEL
s2<-scan(dec=",")
s2<-ts(s2)

#GRAFICA#
plot(s2, main="Serie 2", ylab="");grid()
par(mfrow=c(1,2))
acf(s2, lag.max=30, main="ACF", ci=0)
pacf(s2,lag.max=30, main="PACF")

#POSIVEIS MODELOS
mod21=arima(s2, c(2, 0, 0), method = c("ML"))
res21=residuals(mod21)

mod22=arima(s2, c(5, 0, 0), method = c("ML"))
res22=residuals(mod22)

mod23=arima(s2, c(10, 0, 0), method = c("ML"))
res23=residuals(mod23)


#ESCOLHA SEGUNDO CRITERIO DE INFO 
AIC(mod21, k=2) #AIC
AIC(mod21, k = log(length(s2))) #BIC

AIC(mod22, k=2) #AIC
AIC(mod22, k = log(length(s2))) #BIC

AIC(mod23, k=2) #AIC
AIC(mod23, k = log(length(s2))) #BIC

#MELHOR MODELO AR(2)
mod21=arima(s2, c(2, 0, 0), method = c("ML"))

#ESTIMACAO DOS PARAMETROS
# Estimacion ML exacta
(mod21=arima(s2, c(2, 0, 0), method = c("ML")))

#ANALISE DOS RESIDUALES
res21=residuals(mod21)
par(mfrow=c(3,2))
plot.ts(res21, main="Residuales", ylab="")
hist(res21, main="Histograma de Residuales")
acf(res21, lag.max=25, main="ACF de Residuales")
pacf(res21, lag.max=25, main="PACF de Residuales")


Box.Test(res21)  
shapiro.test(res21)
qqnorm(res21, main="QQ de los Residuales")
qqline(res21)


####################################################################################
####################################################################################
####################################################################################
####################################################################################

####################
## SERIE 3 - ARMA ##
####################

#LER DADOS DESDE EXCEL
s3<-scan(dec=",")
s3<-ts(s3)

#GRAFICA#
plot.ts(s3, main="Serie 3", ylab="");grid()
par(mfrow=c(1,2))
acf(s3, lag.max=50, main="ACF") #, ci=0)
pacf(s3,lag.max=50, main="PACF")

#POSIVEIS MODELOS
mod31=arima(s3, c(2, 0, 1), method = c("ML"))
res31=residuals(mod31)

mod32=arima(s3, c(1, 0, 1), method = c("ML"))
res32=residuals(mod32)

mod33=arima(s3, c(3, 0, 1), method = c("ML"))
res33=residuals(mod33)


#ESCOLHA SEGUNDO CRITERIO DE INFO 
AIC(mod31, k=2) #AIC
AIC(mod31, k = log(length(s2))) #BIC

AIC(mod32, k=2) #AIC
AIC(mod32, k = log(length(s2))) #BIC

AIC(mod33, k=2) #AIC
AIC(mod33, k = log(length(s2))) #BIC

#MELHOR MODELO AR(2)
mod31=arima(s3, c(2, 0, 1), method = c("ML"))

#ESTIMACAO DOS PARAMETROS
# Estimacion ML exacta
(mod31=arima(s3, c(2, 0, 1), method = c("ML")))

#ANALISE DO RESIDUAIS
res31=residuals(mod31)
par(mfrow=c(3,2))
plot.ts(res31, main="Residuales", ylab="")
hist(res31, main="Histograma de Residuales")
acf(res31, lag.max=25, main="ACF de Residuales")
pacf(res31, lag.max=25, main="PACF de Residuales")

Box.Test(res31) 

shapiro.test(res31)
qqnorm(res31, main="QQ de los Residuales")
qqline(res31)


################################################################################
################################################################################
################################################################################


#TEST DE LJUNG-BOX

Box.Test = function(x, lag = 25, main = "p values for Ljung-Box statistic"){
  B<-vector("numeric")
  for(i in 1:lag){
    B[i]<-Box.test(x, lag = i, type = "Ljung-Box")$p.value
  }
  A<-matrix(cbind(c(1:lag),B), nrow = lag, ncol = 2, byrow=F, dimnames = list(NULL, c("lag", "p.value")))
  plot(A[,1], A[,2], ylim = c(0, max(0.051,(max(A[,2])+.01))), 
       ylab = "p-value", xlab = "Lag", main = main, lwd = 2)
  abline(0.05, 0, col = 4, lty = 2)
}
Box.Test(residuos)

################################################################################
################################################################################


#FUNCAO QUE PROCURA O MELHOR MODELO SEGUNDO AIC E BIC#
sarima.list = function(datos, p, d = 0, q, P = 0, D = 0, Q = 0, S = NA, include.mean = F, criterio = ""){
  M <- matrix(ncol = 10,nrow = (p+1)*(q+1)*(P+1)*(Q+1),dimnames=list(NULL,c("p","d","q","P","D","Q","S","converge","AIC", "BIC")))
  k <- 1 
  n <- length(datos)
  for(i in 0:p){
    for(j in 0:q){
      for(l in 0:P){
        for(m in 0:Q){
          if ((i==0)&&(j==0)&&(l==0)&&(m==0)) next #Continua con la siguiente iteracion 
          fit <- arima(datos, order = c(i, d, j),seasonal = list(order = c(l, D, m), period = S), include.mean = include.mean)
          M[k,1]  <- i
          M[k,2]  <- d
          M[k,3]  <- j
          M[k,4]  <- l
          M[k,5]  <- D
          M[k,6]  <- m
          M[k,7]  <- S
          M[k,8]  <- fit$code  # 0: Convergencia, 1: No Convergencia
          M[k,9]  <- AIC(fit)  # AIC
          M[k,10] <- AIC(fit, k = log(length(datos)))  # BIC
          k <- k+1 
        } 
      } 
    }
  }
  if(criterio == "AIC"){
    M <- M[order(M[,9]),]
  }
  if(criterio == "BIC"){
    M <- M[order(M[,10]),]
  }
  if(criterio == ""){
    M <- M
  }
  rownames(M) = rep("", (p+1)*(q+1)*(P+1)*(Q+1))
  return(M[1:((p+1)*(q+1)*(P+1)*(Q+1)-1),]) 
}

#EXEMPLO
sarima.list(s1, p=5, d = 1, q=5, P = 0, D = 0, Q = 0, S = NA, include.mean = F, criterio = "")

################################################################################
################################################################################

#SIMULACAO

#s2<-arima.sim(n = 250, list(ar=c(0.4897, -0.782), sd = sqrt(0.1796)))
#s3<-arima.sim(n = 365, list(ar=c(0.256, -0.516), ma =0.248, sd = sqrt(0.268)))

################################################################################
################################################################################

#EXPORTACAO DADOS PARA EXCEL
library(WriteXLS)
WW<-data.frame(s3)
WriteXLS("WW", "WW.xls")

###################################################################################
###################################################################################

library(nortest)
lillie.test(re)
library(stats)
ks.test(re,"pnorm",mean(re), sd(re))


#AUTO-ARIMA, AJUDA ALTERNATIVA
library(forecast)
r<-auto.arima(s1)$residuals
hist(r)
shapiro.test(r)
Box.test(r, type = c("Box-Pierce", "Ljung-Box"))

##################################################################################
##################################################################################